import processing.opengl.*;
import peasy.org.apache.commons.math.*;
import peasy.*;
import peasy.org.apache.commons.math.geometry.*;

PeasyCam cam;
ArrayList transactions = null;         //create a container for transactions from the data
int squareSize = 5;                   //sets the size of the squares being drawn
int counter = 0;                       //counter to keep track of the transactions being used. 
float value = 0; 
void setup()
{
   ///Set up Canvas 
  size(1000,700,OPENGL);       //setup a 500 by 500 Pixel Space to work with 280 transactions...for you want to show more make sure you have enough transactions in your splxmldata.txt file.
  smooth(); 
  background(0);     //set background to white (255)
  frameRate(1000);       //set the frameRate of the Visualization 
  this.transactions = loadTransactions();   //load the transactions from the splxmldata.txt file 
  cam = new PeasyCam(this, 600);
  cam.setMinimumDistance(1);
  cam.setMaximumDistance(2000);
}

void draw()        //draw loop that runs over and over until user quits
{
  background(0);  //sets the background color to white = 255; 

  Transaction t;     //create a transaction object

  for(int i = 0; i < 400; i = i + squareSize)      //nested for loops to create a grid of squares. 
  {
    for(int k = 0; k < 400; k = k + squareSize)
    {
      t = (Transaction) transactions.get(counter);
      if(t.deweyClass.length() > 0)
      {
          String number = t.deweyClass.substring(0,3);  
          try
          {
            value = (float)Integer.parseInt(number);
          } catch (Exception e)
          {
            value = 0;
          }
          value = map(value,0.0,1000.0,0.0,255.0); 
          fill(value); 
          stroke(value,30);            
          strokeWeight(5+value); 
          line(-200+i,-200+k,0,-200+i,-200+k,1+value);
      }      
      counter = counter + 1;      
    }  
  }  
  strokeWeight(1);   
  axis();   
  counter = 0;             //sets the counter to zero to start over again
}
  
void axis()
{
  stroke(255,0,0); 
  line(1000,0,0,0,0,0);
  stroke(0,255,0); 
  line(0,1000,0,0,0,0);
  stroke(0,0,255); 
  line(0,0,1000,0,0,0);
}
